"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var cache_1 = require("../../cache/cache");
var clientContext_1 = require("../../context/clientContext");
var cache = cache_1.createCache(function () { return true; }, function () { return true; });
exports.useSuspenseQuery = function (action) {
    var clientContext = react_1.useContext(clientContext_1.ClientContext);
    var cacheItem = cache.get(action);
    react_1.useEffect(function () {
        return function () {
            cache.remove(action);
        };
    }, []);
    if (cacheItem) {
        if (cacheItem.response) {
            return cacheItem.response;
        }
        throw cacheItem.fetch;
    }
    var fetch = clientContext.query(action).then(function (res) {
        cache.add(action, {
            fetch: fetch,
            response: res,
        });
    });
    cache.add(action, {
        fetch: fetch,
    });
    throw fetch;
};
